unit UnitModul;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, JvExControls, JvXPCore, JvXPButtons,
  Vcl.Imaging.jpeg, Vcl.ExtCtrls, Vcl.StdCtrls, Vcl.ComCtrls, Vcl.Samples.Spin,
  JvComCtrls, JvComponentBase, JvFormPlacement;

type
  TForm2 = class(TForm)
    JvXPButton1: TJvXPButton;
    Label6: TLabel;
    Label5: TLabel;
    Label2: TLabel;
    IP: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label24: TLabel;
    Label29: TLabel;
    Label30: TLabel;
    IP_ADDRESS: TJvIPAddress;
    MASK_ADDRESS: TJvIPAddress;
    GW_ADDRESS: TJvIPAddress;
    JvXPButton3: TJvXPButton;
    PORT_RX: TSpinEdit;
    PORT_TX: TSpinEdit;
    JvXPButton12: TJvXPButton;
    JvXPButton13: TJvXPButton;
    DHCP_ON: TCheckBox;
    Label32: TLabel;
    Label33: TLabel;
    MYSQL_User: TEdit;
    MYSQL_Pass: TEdit;
    Label1: TLabel;
    Label22: TLabel;
    Label25: TLabel;
    Label28: TLabel;
    MYSQL_PORT: TSpinEdit;
    MYSQL_URL: TEdit;
    JvFormStorage1: TJvFormStorage;
    procedure JvXPButton1Click(Sender: TObject);
    procedure JvXPButton3Click(Sender: TObject);
    procedure JvXPButton12Click(Sender: TObject);
    procedure JvXPButton13Click(Sender: TObject);
    procedure DHCP_ONMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form2: TForm2;

implementation

{$R *.dfm}

uses UnitMain;

procedure TForm2.DHCP_ONMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
          form2.IP_ADDRESS.Enabled := not form2.DHCP_ON.Checked;
          form2.GW_ADDRESS.Enabled := not form2.DHCP_ON.Checked;
end;

procedure TForm2.JvXPButton12Click(Sender: TObject);
var
      Buffer :TArray<System.Byte>;
begin
      Form1.IdUDPClient1.Active := false;
      setlength(Buffer,3);

      Buffer[0] := byte(ord('M'));
      Buffer[1] := byte(ord('Y'));
      Buffer[2] := byte(ord('1'));
      Form1.IdUDPClient1.SendBuffer(ip.caption, Form1.UDP_Port.value, buffer );
end;

procedure TForm2.JvXPButton13Click(Sender: TObject);
var
      Buffer :TArray<System.Byte>;
begin
      Form1.IdUDPClient1.Active := false;
      setlength(Buffer,3);

      Buffer[0] := byte(ord('M'));
      Buffer[1] := byte(ord('Y'));
      Buffer[2] := byte(ord('2'));
      Form1.IdUDPClient1.SendBuffer(ip.caption, Form1.UDP_Port.value, buffer );
end;

procedure TForm2.JvXPButton1Click(Sender: TObject);
begin
    if MessageDlg('Close without storing changes?',  mtConfirmation, [mbYes, mbNo], 0) = mrYes then
       close;
end;

procedure TForm2.JvXPButton3Click(Sender: TObject);
var
      Buffer: TArray<System.Byte>;
      test : string;
      i, j, k : integer;
      c : string;
begin
      setlength(Buffer,100);
      Form1.IdUDPClient1.Active := false;

      Buffer[0] := byte(ord('S'));
      Buffer[1] := byte(ord('E'));
      Buffer[2] := byte(ord('T'));

      test := IP_ADDRESS.text;
      Buffer[3] := IP_ADDRESS.AddressValues.Value1;
      Buffer[4] := IP_ADDRESS.AddressValues.Value2;
      Buffer[5] := IP_ADDRESS.AddressValues.Value3;
      Buffer[6] := IP_ADDRESS.AddressValues.Value4;

      test := MASK_ADDRESS.text;
      Buffer[7] := MASK_ADDRESS.AddressValues.Value1;
      Buffer[8] := MASK_ADDRESS.AddressValues.Value2;
      Buffer[9] := MASK_ADDRESS.AddressValues.Value3;
      Buffer[10] := MASK_ADDRESS.AddressValues.Value4;

      test := GW_ADDRESS.text;
      Buffer[11] := GW_ADDRESS.AddressValues.Value1;
      Buffer[12] := GW_ADDRESS.AddressValues.Value2;
      Buffer[13] := GW_ADDRESS.AddressValues.Value3;
      Buffer[14] := GW_ADDRESS.AddressValues.Value4;

      Buffer[15] := ( PORT_TX.Value shr 8) and $FF;
      Buffer[16] := PORT_TX.Value and $FF;

      Buffer[17] := ( PORT_RX.Value shr 8) and $FF;
      Buffer[18] := PORT_RX.Value and $FF;

      Buffer[19]   := (MYSQL_PORT.Value shr 8) and $FF;
      Buffer[20] := (MYSQL_PORT.Value and $FF);

      K := 21;
      Buffer[k] := length(trim(MYSQL_URL.Text));
      k := k + 1;
      for i := 1 to length(trim(MYSQL_URL.Text)) do begin
          c := copy(trim(MYSQL_URL.Text),i,1);
          Buffer[k] := ord(c[1]);
          k := k + 1;
      end;

      Buffer[k] := length(trim(MYSQL_User.Text));
      k := k + 1;
      for i := 1 to length(trim(MYSQL_User.Text)) do begin
          c := copy(trim(MYSQL_User.Text),i,1);
          Buffer[k] := ord(c[1]);
          k := k + 1;
      end;

      Buffer[k] := length(trim(MYSQL_Pass.Text));
      k := k + 1;
      for i := 1 to length(trim(MYSQL_Pass.Text)) do begin
          c := copy(trim(MYSQL_Pass.Text),i,1);
          Buffer[k] := ord(c[1]);
          k := k + 1;
      end;

      if DHCP_ON.Checked then
          Buffer[k] := 1
      else
          Buffer[k] := 0;
      k := k + 1;


      setlength(Buffer,k);

      Form1.IdUDPClient1.SendBuffer(ip.caption, Form1.UDP_Port.value, buffer );

      Form1.IdUDPClient1.Active := True;

      Form1.ADD_LOG(ip.caption,inttostr(Form1.UDP_Port.value), 'UPDATE DEVICE');
      close;
end;

end.
